package zk.support;

import org.zkoss.bind.annotation.BindingParam;
import org.zkoss.bind.annotation.Command;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zul.AbstractListModel;
import org.zkoss.zul.ListModel;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.ListSubModel;

public class ChosenboxViewModel {
	private ListModel<String> chosenboxModel = new BigDataListModel();
	private ListModel<String> comboboxModel = new BigDataListModel();

	public ListModel<String> getComboboxModel() {
		return comboboxModel;
	}
	
	public ListModel<String> getChosenboxModel() {
		return chosenboxModel;
	}
	
	class BigDataListModel extends AbstractListModel<String> implements ListSubModel<String> {

		public String getElementAt(int index) {
			String string = Integer.valueOf(index).toString(index, 36);
			System.out.println("getElementAt called for : " + index + " -> " + string);
			return string;
		}

		public int getSize() {
			return 50000;
		}
		
		public ListModel<String> getSubModel(Object value, int nRows) {
			System.out.println(String.format("sublist called: \"%s\", %d", value, nRows));
			ListModelList<String> subList = new ListModelList<String>();
			if("".equals(value)) {
				return subList;
			}
			for(int i = 0; i < 10; i++) {
				long number = Long.parseLong((String)value + i, 36);
				if(number > getSize()) {
					break;
				}
				subList.add(getElementAt((int)number));
			}
			System.out.println(subList);
			return subList;
		}
		
	}
}
